%define debug_package %{nil}
########################################################################
# On CentOS/RHEL, if the Software Configurations Library is installed
# and Python 2.7 is installed, then it is used. This is only available
# on CentOS 6.5 for the x86_64 architecture, at this time.
########################################################################
%define __SCL	%(if [ -d /opt/rh/python27 ]; then echo 1; else echo 0; fi)

%if 0%{?__SCL} > 0 
	%define PYTHON     python27
	%define python_sitelib_old_1 %(%{__python} -c "from distutils.sysconfig import get_python_lib; print get_python_lib(plat_specific=False)")
	%define python_sitelib_old_2 %(%{__python} -c "from distutils.sysconfig import get_python_lib; print get_python_lib(plat_specific=True)")
	%define python_sitelib %(echo python -c '"from distutils.sysconfig import get_python_lib; print get_python_lib(plat_specific=False)"' | scl enable python27 -)
	%define _SCL_base %(echo $(dirname $(dirname `echo which python | scl enable python27 -`)))
	%define _bindir %(dirname `echo which python | scl enable python27 -`)
	%define _datadir %{_SCL_base}/share
	%define _mandir %{_datadir}/man
	%define _docdir %{_datadir}/doc
	%define  __os_install_post	\
	    /usr/lib/rpm/redhat/brp-compress; \
	    %{!?__debug_package:/usr/lib/rpm/redhat/brp-strip %{__strip}}; \
	    /usr/lib/rpm/redhat/brp-strip-static-archive %{__strip}; \
	    /usr/lib/rpm/redhat/brp-strip-comment-note %{__strip} %{__objdump}; \
	    echo /usr/lib/rpm/brp-python-bytecompile python27 | scl enable %{PYTHON} - ; \
	    /usr/lib/rpm/redhat/brp-python-hardlink; \
	    %{!?__jar_repack:/usr/lib/rpm/redhat/brp-java-repack-jars}
%else
	%define python_sitelib %(%{__python} -c "from distutils.sysconfig import get_python_lib; print get_python_lib(plat_specific=False)")
%endif

Name:           python-registry
Version:        1.1.0
Release:        2%{?dist}
Group:          Development/Libraries/Python
Summary:        Read access to Windows Registry Files
License:        Apache 2.0
URL:            http://www.williballenthin.com/registry/
Source:		%{name}-%{version}.tar.gz
Patch1:		%{name}-%{version}-patch-001
%if 0%{?__SCL} > 0
BuildRequires:  python27-python-setuptools
Requires:       python27-python-setuptools
%else
Requires:       python >= 2.7
BuildRequires:  python >= 2.7
%endif

%description
python-registry was originally written by Willi Ballenthin, a forensicator at Mandiant who wanted to access the contents of the 
Windows Registry from his Linux laptop. python-registry currently provides read-only access to Windows Registry files, 
such as NTUSER.DAT, userdiff, and SAM. The interface is two-fold: a high-level interface suitable for most tasks, and a low level 
set of parsing objects and methods which may be used for advanced study of the Windows Registry. python-registry is written in pure 
Python, making it portable across all major platforms.

%prep
########################################################################
# The system script that computes dependencies misidentifies the 
# python 2.7 dependency, so it is necessary to remove it from the
# dependency determination. 
########################################################################
%if 0%{?__SCL} > 0
cat > /tmp//pythondeps.sh << \EOF
#!/bin/sh
%{__python_requires} $* | sed -e 's/python(abi) = 2.7/python27-python(abi) = 2.7/'
EOF
chmod +x /tmp/pythondeps.sh
%define __python_requires /tmp/pythondeps.sh
%endif

%setup
%patch1 -p1

%build
%if 0%{?__SCL} > 0
        echo python setup.py build | scl enable python27 -
%else
        %{__python} setup.py build
%endif

%install
%if 0%{?__SCL} > 0
	echo %{__python} setup.py install --prefix=%{_prefix} --root $RPM_BUILD_ROOT --install-purelib=%{python_sitelib} | scl enable python27 -
%else
	%{__python} setup.py install --prefix=%{_prefix} --root $RPM_BUILD_ROOT 
%endif


%clean
%{__rm} -rf $RPM_BUILD_ROOT

%files
%doc LICENSE.TXT README.MD
%defattr(-,root,root,-)
%attr(0644, root, root)		%{python_sitelib}/Registry/*
%attr(0644, root, root)		%{python_sitelib}/*egg-info

%changelog -n python-registry
* Thu Feb 26 2015 Willi Ballenthin <willi.ballenthin@gmail.com> 1.1.0-2
* Release 1.1.0-2
	This is the version available on 2015-02-26 which is a patch to 1.1.0 making release 2.

* Mon Feb 16 2015 Willi Ballenthin <willi.ballenthin@gmail.com> 1.1.0-1
* Release 1.1.0-1
	1.1.0
	- add raw_data method
	- fix testing scripts and methods
	- add amcache.hve parsing script
	- add script for mounting hive as file system via FUSE
	- many fixes, including checksum calculations, by @NiKiZe
	- fixes to RegDateTime parsing by @woanware
* Thu Jul  3 2014 Willi Ballenthin <willi.ballenthin@gmail.com> 1.0.4-1
* Release 1.0.4-1
	1.0.4
	  - correctly handle value types on Vista+ that require a DEVPROP_MASK_TYPE mask, thanks to @woanware
	  - support the new RegDateTime value type, used for instance in some USBSTOR values, thanks to @woanware

	1.0.3
	  - use setuptools over distutils

	1.0.2
	  - can now fetch hive name from a Registry hive, thanks to @woanware, @jallmantalbot
	  - can now guess the Registry hive type (NTUSER, USRCLASS, etc) from the hive name, thanks to @woanware
	  - better handling of key/value names through use of Windows-1252 encoding, thanks to @jallmantalbot and Joel Schnieder

* Tue Jan 14 2014 Willi Ballenthin <willi.ballenthin@gmail.com> 1.0.1-1
* Release 1.0.1-1
	1.0.1
	  - better detection and handling of malformed Unicode, thanks to @jallmantalbot and matt.a.hastings
	  - minor changes to formatting in sample scripts

	1.0.0
	  - implemented Python3 support thanks to @3ev0

* Wed Jan 4 2012 Willi Ballenthin <willi.ballenthin@gmail.com> 0.2.3-1
* Release 0.2.3-1
